/**
 * 
 */
package com.wieseke.cptk.common.api;

import java.util.List;

import com.wieseke.cptk.common.dao.ParasiteRank;

/**
 * @author Nicolas Wieseke
 * 
 */
public interface IParasiteNode extends INode {

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.common.api.INode#getParent()
	 */
	
	public IParasiteNode getParent();

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.common.api.INode#getChildren()
	 */
	
	public List<? extends IParasiteNode> getChildren();

	/**
	 * @return the rank
	 */
	public ParasiteRank getRank();

	/**
	 * @param rank
	 *            the rank to set
	 */
	public void setRank(ParasiteRank rank);

	/**
	 * @return the associations
	 */
	public List<? extends IHostNode> getAssociations();

}
