/**
 * 
 */
package com.wieseke.cptk.common.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;

import com.wieseke.cptk.input.preferences.InputPreferenceInitializer;
import com.wieseke.cptk.output.preferences.OutputPreferenceInitializer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	public PreferenceInitializer() {
		super();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @seeorg.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#
	 * initializeDefaultPreferences()
	 */
	
	public void initializeDefaultPreferences() {
		new InputPreferenceInitializer().initializeDefaultPreferences();
		new OutputPreferenceInitializer().initializeDefaultPreferences();
	}
}
