/**
 * 
 */
package com.wieseke.cptk.common.util;

/**
 * @author Nic
 * 
 */
public class Tripel<T1, T2, T3> {

	/**
	 * the first value
	 */
	private T1 value1;
	/**
	 * the second value
	 */
	private T2 value2;
	/**
	 * the third value
	 */
	private T3 value3;

	/**
	 * default constructor
	 * 
	 * @param value1
	 * @param value2
	 */
	public Tripel(T1 value1, T2 value2, T3 value3) {
		this.value1 = value1;
		this.value2 = value2;
		this.value3 = value3;
	}

	/**
	 * @return the value1
	 */
	public T1 getValue1() {
		return value1;
	}

	/**
	 * @param value1
	 *            the value1 to set
	 */
	public void setValue1(T1 value1) {
		this.value1 = value1;
	}

	/**
	 * @return the value2
	 */
	public T2 getValue2() {
		return value2;
	}

	/**
	 * @param value2
	 *            the value2 to set
	 */
	public void setValue2(T2 value2) {
		this.value2 = value2;
	}

	/**
	 * @return the value3
	 */
	public T3 getValue3() {
		return value3;
	}

	/**
	 * @param value3
	 *            the value3 to set
	 */
	public void setValue3(T3 value3) {
		this.value3 = value3;
	}

	/**
	 * @param value1
	 * @param value2
	 * @param value3
	 * @return the old values
	 */
	public Tripel<T1, T2, T3> setValues(T1 value1, T2 value2, T3 value3) {
		Tripel<T1, T2, T3> oldValue = new Tripel<T1, T2, T3>(this.value1,
				this.value2, this.value3);
		this.value1 = value1;
		this.value2 = value2;
		this.value3 = value3;
		return oldValue;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((value1 == null) ? 0 : value1.hashCode());
		result = prime * result + ((value2 == null) ? 0 : value2.hashCode());
		result = prime * result + ((value3 == null) ? 0 : value3.hashCode());
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Tripel<?, ?, ?> other = (Tripel<?, ?, ?>) obj;
		if (value1 == null) {
			if (other.value1 != null)
				return false;
		} else if (!value1.equals(other.value1))
			return false;
		if (value2 == null) {
			if (other.value2 != null)
				return false;
		} else if (!value2.equals(other.value2))
			return false;
		if (value3 == null) {
			if (other.value3 != null)
				return false;
		} else if (!value3.equals(other.value3))
			return false;
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return this.value1.toString() + ":" + this.value2.toString() + ":"
				+ this.value3.toString();
	}

}
