/**
 * 
 */
package com.wieseke.cptk.output.action;

import com.wieseke.cptk.output.viewer.OutputCophylogenyViewer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ReconstructionNextAction extends OutputAction {

	/**
	 * default constructor
	 * 
	 * @param text
	 */
	public ReconstructionNextAction(String text) {
		super(text);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	
	public void run() {
		if (this.viewer != null) {
			if (this.viewer instanceof OutputCophylogenyViewer) {
				((OutputCophylogenyViewer) this.viewer)
						.showNextReconstruction();
			}
		}
	}
}
