/**
 * 
 */
package com.wieseke.cptk.reconstruction.dao;

import java.util.List;

import com.wieseke.cptk.common.api.IHostNode;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ReconstructionHostNode extends ReconstructionNode implements IHostNode {

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.common.dao.Node#getParent()
	 */
	
	public ReconstructionHostNode getParent() {
		return (ReconstructionHostNode) super.getParent();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.reconstruction.dao.ReconstructionNode#getChildren()
	 */
	@SuppressWarnings("unchecked")
	
	public List<ReconstructionHostNode> getChildren() {
		return (List<ReconstructionHostNode>) super.getChildren();
	}

	/**
	 * the timezone of the host node
	 */
	public int rank;

	/**
	 * default constructor
	 * 
	 * @param node
	 */
	public ReconstructionHostNode(IHostNode node) {
		super(node);
		this.setRank(node.getRank());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.common.api.IHostNode#getRank()
	 */
	
	public int getRank() {
		return rank;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.wieseke.cptk.common.api.IHostNode#setRank(int)
	 */
	
	public void setRank(int rank) {
		this.rank = rank;
	}
}
